#line 945 "../../src/builtin/snarf.m4"
/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 945
#ifdef HAVE_CONFIG_H
#line 945
# include <config.h>
#line 945
#endif
#line 945
#include <sys/types.h>
#line 945

#line 945
#include "mailfromd.h"
#line 945
#include "prog.h"
#line 945
#include "builtin.h"
#line 945

#line 945

#line 985 "../../src/builtin/snarf.m4"

/* End of snarf.m4 */
#line 1 "vars.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2019 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "filenames.h" /* For DEFAULT_FROM_ADDRESS */
static size_t rcpt_count_loc
#line 20 "vars.bi"
;
static size_t milter_client_family_loc
#line 21 "vars.bi"
;
static size_t milter_client_address_loc
#line 22 "vars.bi"
;
static size_t milter_server_family_loc
#line 23 "vars.bi"
;
static size_t milter_server_address_loc
#line 24 "vars.bi"
;
static size_t milter_server_id_loc
#line 25 "vars.bi"
;
static size_t sendmail_header_count_loc
#line 26 "vars.bi"
;

/* Functions to access %rcpt_count */
unsigned long
get_rcpt_count(eval_environ_t env)
{
 	return mf_c_val(*env_data_ref(env, rcpt_count_loc),long) ;
}

void
clear_rcpt_count(eval_environ_t env)
{
	mf_c_val(*env_data_ref(env, rcpt_count_loc),long) = (0);
}

void
incr_rcpt_count(eval_environ_t env)
{
	env_var_inc(env, rcpt_count_loc);
}

/* Same for sendmail_header_count */
unsigned long
get_sendmail_header_count(eval_environ_t env)
{
 	return mf_c_val(*env_data_ref(env, sendmail_header_count_loc),long) ;
}

void
set_sendmail_header_count(eval_environ_t env, unsigned long v)
{
 	mf_c_val(*env_data_ref(env, sendmail_header_count_loc),ulong) = (v);
}

/* define_milter_address name */
#line 105

	  

#line 107

#line 107
void
#line 107
set_milter_server_address(eval_environ_t env, milter_sockaddr_t *addr,
#line 107
		      socklen_t len)
#line 107
{
#line 107
	char *path;
#line 107
	
#line 107
	switch (addr->sa.sa_family) {
#line 107
	case PF_INET:
#line 107
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = (MFAM_INET);
#line 107
		
#line 107
{ size_t __off;
#line 107
  const char *__s = inet_ntoa(addr->sin.sin_addr);
#line 107
  if (__s)
#line 107
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 107
  else
#line 107
     __off = 0;
#line 107
  mf_c_val(*env_data_ref(env, milter_server_address_loc),size) = (__off); }
#line 107
;
#line 107
		break;
#line 107

#line 107
#ifdef GACOPYZ_IPV6
#line 107
	case PF_INET6: {
#line 107
		char hostbuf[NI_MAXHOST];
#line 107

#line 107
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = (MFAM_INET6);
#line 107
		if (getnameinfo(&addr->sa, sizeof(addr->sin6),
#line 107
				hostbuf, sizeof hostbuf,
#line 107
				NULL, 0,
#line 107
				NI_NUMERICHOST|NI_NUMERICSERV))
#line 107
			hostbuf[0] = 0;
#line 107
		
#line 107
{ size_t __off;
#line 107
  const char *__s = hostbuf;
#line 107
  if (__s)
#line 107
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 107
  else
#line 107
     __off = 0;
#line 107
  mf_c_val(*env_data_ref(env, milter_server_address_loc),size) = (__off); }
#line 107
;
#line 107
		break;
#line 107
	}
#line 107
#endif
#line 107
		
#line 107
	case PF_UNIX:
#line 107
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = (MFAM_UNIX);
#line 107
		if (len == sizeof (addr->sa.sa_family))
#line 107
			path = "";
#line 107
		else
#line 107
			path = addr->sunix.sun_path;
#line 107
		
#line 107
{ size_t __off;
#line 107
  const char *__s = path;
#line 107
  if (__s)
#line 107
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 107
  else
#line 107
     __off = 0;
#line 107
  mf_c_val(*env_data_ref(env, milter_server_address_loc),size) = (__off); }
#line 107
;
#line 107
		break;
#line 107
		
#line 107
	default:
#line 107
		/* FIXME */
#line 107
		mf_c_val(*env_data_ref(env, milter_server_family_loc),long) = ((long)addr->sa.sa_family);
#line 107
	}
#line 107
}
#line 107

#line 107

#line 107

#line 107


#line 108

#line 108
void
#line 108
set_milter_client_address(eval_environ_t env, milter_sockaddr_t *addr,
#line 108
		      socklen_t len)
#line 108
{
#line 108
	char *path;
#line 108
	
#line 108
	switch (addr->sa.sa_family) {
#line 108
	case PF_INET:
#line 108
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = (MFAM_INET);
#line 108
		
#line 108
{ size_t __off;
#line 108
  const char *__s = inet_ntoa(addr->sin.sin_addr);
#line 108
  if (__s)
#line 108
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 108
  else
#line 108
     __off = 0;
#line 108
  mf_c_val(*env_data_ref(env, milter_client_address_loc),size) = (__off); }
#line 108
;
#line 108
		break;
#line 108

#line 108
#ifdef GACOPYZ_IPV6
#line 108
	case PF_INET6: {
#line 108
		char hostbuf[NI_MAXHOST];
#line 108

#line 108
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = (MFAM_INET6);
#line 108
		if (getnameinfo(&addr->sa, sizeof(addr->sin6),
#line 108
				hostbuf, sizeof hostbuf,
#line 108
				NULL, 0,
#line 108
				NI_NUMERICHOST|NI_NUMERICSERV))
#line 108
			hostbuf[0] = 0;
#line 108
		
#line 108
{ size_t __off;
#line 108
  const char *__s = hostbuf;
#line 108
  if (__s)
#line 108
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 108
  else
#line 108
     __off = 0;
#line 108
  mf_c_val(*env_data_ref(env, milter_client_address_loc),size) = (__off); }
#line 108
;
#line 108
		break;
#line 108
	}
#line 108
#endif
#line 108
		
#line 108
	case PF_UNIX:
#line 108
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = (MFAM_UNIX);
#line 108
		if (len == sizeof (addr->sa.sa_family))
#line 108
			path = "";
#line 108
		else
#line 108
			path = addr->sunix.sun_path;
#line 108
		
#line 108
{ size_t __off;
#line 108
  const char *__s = path;
#line 108
  if (__s)
#line 108
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 108
  else
#line 108
     __off = 0;
#line 108
  mf_c_val(*env_data_ref(env, milter_client_address_loc),size) = (__off); }
#line 108
;
#line 108
		break;
#line 108
		
#line 108
	default:
#line 108
		/* FIXME */
#line 108
		mf_c_val(*env_data_ref(env, milter_client_family_loc),long) = ((long)addr->sa.sa_family);
#line 108
	}
#line 108
}
#line 108

#line 108

#line 108

#line 108



#line 110

#line 110
void
#line 110
set_milter_server_id(eval_environ_t env, const char *id)
#line 110
{
#line 110
	
#line 110
{ size_t __off;
#line 110
  const char *__s = id ? id : "";
#line 110
  if (__s)
#line 110
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 110
  else
#line 110
     __off = 0;
#line 110
  mf_c_val(*env_data_ref(env, milter_server_id_loc),size) = (__off); }
#line 110
;
#line 110
}
#line 110

#line 110

#line 110

#line 116


#line 945 "../../src/builtin/snarf.m4"

#line 945

#line 945

#line 945
void
#line 945
vars_init_builtin(void)
#line 945
{
#line 945
	
#line 945
	#line 20 "vars.bi"
	builtin_variable_install("rcpt_count", dtype_number, SYM_VOLATILE, &rcpt_count_loc);
#line 21 "vars.bi"
	builtin_variable_install("milter_client_family", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &milter_client_family_loc);
#line 22 "vars.bi"
	builtin_variable_install("milter_client_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_client_address_loc);
#line 23 "vars.bi"
	builtin_variable_install("milter_server_family", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_family_loc);
#line 24 "vars.bi"
	builtin_variable_install("milter_server_address", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_address_loc);
#line 25 "vars.bi"
	builtin_variable_install("milter_server_id", dtype_string, SYM_VOLATILE|SYM_PRECIOUS, &milter_server_id_loc);
#line 26 "vars.bi"
	builtin_variable_install("sendmail_header_count", dtype_number, SYM_VOLATILE|SYM_PRECIOUS, &sendmail_header_count_loc);

#line 945 "../../src/builtin/snarf.m4"
	
#line 945
}
#line 945 "../../src/builtin/snarf.m4"

